image: docker:stable

include:
  - project: "operator-ict/devops/gitlab-ci-pipeline"
    file:
      - "/code-quality/sonar-cloud.yml"

stages:
  - test
  - deploy

test:
  stage: test
  image: node:18.17.0-alpine
  script:
    - npm install --progress=false
    - npm run lint
    # Audit production dependencies for HIGH vulnerabilities
    - npm audit --omit dev --audit-level high
    - npm run build
    - npm run code-coverage
  tags:
    - docker

npm_publish:
  image: node:18.17.0-alpine
  stage: deploy
  script:
    - env
    - tmp=$(mktemp)
    - export NPM_TAG=latest
    - if [ "$CI_COMMIT_REF_NAME" == "release" ]; then export VERSION_SUFFIX=rc; else export VERSION_SUFFIX=dev; fi
    - >
        if [ "$CI_COMMIT_REF_NAME" != "master" ]; then
            export NPM_TAG=$VERSION_SUFFIX;
            export PACKAGE_VERSION=$(node -p "require('./package.json').version")
            npm version --no-git-tag-version --new-version "$PACKAGE_VERSION-$VERSION_SUFFIX.$CI_PIPELINE_ID"
            cat package.json
        fi
    - echo '//registry.npmjs.org/:_authToken=${NPMJS_TOKEN}'>>.npmrc
    - npm install --ignore-scripts --progress=false
    - npm run build
    - npm publish --access public --tag $NPM_TAG
  rules:
    - if: $SKIP_NPM_PUBLISH
      when: never
    - if: $CI_COMMIT_REF_PROTECTED == "true"
  tags:
    - docker


pages:
  stage: deploy
  image: node:18.17.0-alpine
  script:
  - npm install
  - npm run generate-docs
  - mv docs/typedoc public
  artifacts:
    paths:
    - public
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
  tags:
    - docker
